//+------------------------------------------------------------------+
//|                                                   Screenshot.mq4 |
//+------------------------------------------------------------------+
#property copyright "Copyright  2012, David Louisson"
#property link      "http://www.forexfactory.com/hanover"

#include <hanover --- function header.mqh>

extern string     FilePrefix                 = "screenshots\@WSS";
extern string     RefreshPeriod              = "H1";
extern int        WidthInPixels              = 1920;
extern int        HeightInPixels             = 1080;
extern int        StartBar                   = -1;
extern int        ChartScale                 = -1;
extern int        ChartMode                  = 1;

string     ccy, sym, IndiName;
int        dig, tf, tmf, vis, wno, RefreshEveryXMins;
double     spr, pnt, tickval, bidp, askp, minlot, lswap, sswap, NewSL;
datetime   prev_time;
bool       FirstTime;

//+------------------------------------------------------------------+
int init()  {
//+------------------------------------------------------------------+
  sym     = Symbol();
  ccy     = Symbol();
  tmf     = Period();
  bidp    = MarketInfo(ccy,MODE_BID);
  askp    = MarketInfo(ccy,MODE_ASK);
  pnt     = MarketInfo(ccy,MODE_POINT);
  dig     = MarketInfo(ccy,MODE_DIGITS);
  spr     = MarketInfo(ccy,MODE_SPREAD);
  tickval = MarketInfo(ccy,MODE_TICKVALUE);
  minlot  = MarketInfo(ccy,MODE_MINLOT);
  lswap   = MarketInfo(ccy,MODE_SWAPLONG);
  sswap   = MarketInfo(ccy,MODE_SWAPSHORT);
  if (dig == 3 || dig == 5) {
    pnt     *= 10;
    spr     /= 10;
    tickval *= 10;
  } 
  RefreshEveryXMins = StrToTF(RefreshPeriod);
  prev_time = -9999;
  return(0);
}

//+------------------------------------------------------------------+
int deinit()  {
//+------------------------------------------------------------------+
  return(0);
}

//+------------------------------------------------------------------+
int start()  {
//+------------------------------------------------------------------+
  if (RefreshEveryXMins < 0)  {
    if (FirstTime)  {
      plot_obj();
    }
    FirstTime = false;      
    return(0);
  }  
  if (RefreshEveryXMins == 0) {
    plot_obj();    
  } else {
    if (prev_time != iTime(sym,RefreshEveryXMins,0))  {
      plot_obj();
      prev_time = iTime(sym,RefreshEveryXMins,0);
  } }      
  return(0);
}

//+------------------------------------------------------------------+
void plot_obj()   {
//+------------------------------------------------------------------+
  WindowScreenShot(FilePrefix+"-"+ExpandCcy(ccy)+","+TFToStr(tmf)+DateToStr(TimeCurrent(),"','Y-M-D H-I-S'.JPG'"),WidthInPixels,HeightInPixels,StartBar,ChartScale,ChartMode);
  return(0);
}

//+------------------------------------------------------------------+
#include <hanover --- extensible functions.mqh>